/* 
	HexEditEngine.cpp

	Author:			Max Horn
	Description:	<describe the HexEditEngine class here>
*/

#include	"MacZoop.h"
#include	"HexEditEngine.h"

#define		DUMMY_DATA_LEN		1024

HexEditEngine::HexEditEngine()
{
	mDataHandle = ::NewHandle( DUMMY_DATA_LEN );
	
	for(int i = 0; i < DUMMY_DATA_LEN; i++)
		 (*mDataHandle)[i] = GetRandom(0,255);
}


HexEditEngine::~HexEditEngine()
{
	::DisposeHandle( mDataHandle );
}


Byte	HexEditEngine::GetByte( long addr )
{
	ASSERT("no mDataHandle allocated!", mDataHandle != NULL, 0)
	ASSERT("data bounds exceeded!", (addr >= 0) && (addr < ::GetHandleSize(mDataHandle)), 0)
	
	return (*mDataHandle)[addr];
}


long	HexEditEngine::GetLength()
{
	ASSERT("no mDataHandle allocated!", mDataHandle != NULL, 0)

	return ::GetHandleSize( mDataHandle );
}

